Subject: Re: [PATCH] HTB updates class's bstats in one place

From: Patrick McHardy <[email-masked]>
Date: Thu, 30 Oct 2008 08:11:58 +0100

Changli Gao wrote:
> On Wed, Oct 29, 2008 at 6:33 PM, Patrick McHardy <[email-masked]> wrote:
>> Only for purely informational purposes, for policing you'd want to
>> use arrival rates. Since there are no users of estimators in the kernel
>> besides policers (which use seperate ones), the point is not terribly
>> important.
> 
> Where can I find sth. about this?
> 
> In fact, this bug is encountered when I am trying to implement a
> statistic daemon in user space. It fetches the classes's statistics
> data periodicity, then calculates the rate based on the data fetched.
> In some cases, it reports the leaf classes's rate is over theirs
> limit, but its ascent's isn't.
> 
> I think there must be someone does the same thing as me. So the
> feature is important for them too. If we don't fix it, how can I
> archive my requirement? Any comment?

Independant of this statistics bug, according to your description
you want to measure departure rates (otherwise the measured rates
can't really be compared to the limit) and the current counters are
not really suitable for this since they count arriving packets.
So the only way to properly do this is to add seperate counters that
account for departing packets. I think this would be a good addition
since we've always been advocating to do this stuff in userspace,
but it would need some thought on how to minimize the impact for
people not needing it.